# Generated by ariadne-codegen
# Source: resources/ariadne_client_configs/transactions.graphql

from typing import Any, Dict, Optional, Union

from .async_base_client import AsyncBaseClient
from .base_model import UNSET, UnsetType
from .enums import DepositWithdrawAction
from .hswap_buy_nft_tx import HswapBuyNftTx
from .hswap_sell_nft_tx import HswapSellNftTx
from .input_types import PoolConfig
from .take_bid_tx import TakeBidTx
from .tcomp_bid_tx_for_collection import TcompBidTxForCollection
from .tcomp_buy_tx import TcompBuyTx
from .tcomp_cancel_coll_bid_tx import TcompCancelCollBidTx
from .tcomp_delist_tx import TcompDelistTx
from .tcomp_edit_bid_tx import TcompEditBidTx
from .tcomp_edit_tx import TcompEditTx
from .tcomp_list_tx import TcompListTx
from .tcomp_take_bid_tx import TcompTakeBidTx
from .tswap_buy_nft_tx import TswapBuyNftTx
from .tswap_buy_single_listing_tx import TswapBuySingleListingTx
from .tswap_close_pool_tx import TswapClosePoolTx
from .tswap_delist_nft_tx import TswapDelistNftTx
from .tswap_deposit_withdraw_nft_tx import TswapDepositWithdrawNftTx
from .tswap_deposit_withdraw_sol_tx import TswapDepositWithdrawSolTx
from .tswap_edit_pool_tx import TswapEditPoolTx
from .tswap_edit_single_listing_tx import TswapEditSingleListingTx
from .tswap_exchange_nft_tx import TswapExchangeNftTx
from .tswap_init_pool_tx import TswapInitPoolTx
from .tswap_list_nft_tx import TswapListNftTx
from .tswap_sell_nft_tx import TswapSellNftTx


def gql(q: str) -> str:
    return q


class TransactionsClientAsync(AsyncBaseClient):
    async def tcomp_buy_tx(
        self, buyer: str, max_price: Any, mint: str, owner: str, **kwargs: Any
    ) -> TcompBuyTx:
        query = gql(
            """
            query TcompBuyTx($buyer: String!, $maxPrice: Decimal!, $mint: String!, $owner: String!) {
              tcompBuyTx(buyer: $buyer, maxPrice: $maxPrice, mint: $mint, owner: $owner) {
                txs {
                  tx
                  txV0
                  lastValidBlockHeight
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "buyer": buyer,
            "maxPrice": max_price,
            "mint": mint,
            "owner": owner,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TcompBuyTx.model_validate(data)

    async def tcomp_list_tx(
        self, mint: str, owner: str, price: Any, **kwargs: Any
    ) -> TcompListTx:
        query = gql(
            """
            query TcompListTx($mint: String!, $owner: String!, $price: Decimal!) {
              tcompListTx(mint: $mint, owner: $owner, price: $price) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"mint": mint, "owner": owner, "price": price}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TcompListTx.model_validate(data)

    async def tcomp_take_bid_tx(
        self, min_price: Any, mint: str, seller: str, **kwargs: Any
    ) -> TcompTakeBidTx:
        query = gql(
            """
            query TcompTakeBidTx($minPrice: Decimal!, $mint: String!, $seller: String!) {
              tcompTakeBidTx(minPrice: $minPrice, mint: $mint, seller: $seller) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "minPrice": min_price,
            "mint": mint,
            "seller": seller,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TcompTakeBidTx.model_validate(data)

    async def tcomp_delist_tx(
        self, mint: str, owner: str, **kwargs: Any
    ) -> TcompDelistTx:
        query = gql(
            """
            query TcompDelistTx($mint: String!, $owner: String!) {
              tcompDelistTx(mint: $mint, owner: $owner) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"mint": mint, "owner": owner}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TcompDelistTx.model_validate(data)

    async def tcomp_edit_tx(
        self, mint: str, owner: str, price: Any, **kwargs: Any
    ) -> TcompEditTx:
        query = gql(
            """
            query TcompEditTx($mint: String!, $owner: String!, $price: Decimal!) {
              tcompEditTx(mint: $mint, owner: $owner, price: $price) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"mint": mint, "owner": owner, "price": price}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TcompEditTx.model_validate(data)

    async def tcomp_bid_tx_for_collection(
        self,
        owner: str,
        price: Any,
        quantity: float,
        slug: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> TcompBidTxForCollection:
        query = gql(
            """
            query TcompBidTxForCollection($owner: String!, $price: Decimal!, $quantity: Float!, $slug: String) {
              tcompBidTx(owner: $owner, price: $price, quantity: $quantity, slug: $slug) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "owner": owner,
            "price": price,
            "quantity": quantity,
            "slug": slug,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TcompBidTxForCollection.model_validate(data)

    async def tcomp_edit_bid_tx(
        self,
        bid_state_address: str,
        price: Union[Optional[Any], UnsetType] = UNSET,
        quantity: Union[Optional[float], UnsetType] = UNSET,
        **kwargs: Any
    ) -> TcompEditBidTx:
        query = gql(
            """
            query TcompEditBidTx($bidStateAddress: String!, $price: Decimal, $quantity: Float) {
              tcompEditBidTx(
                bidStateAddress: $bidStateAddress
                price: $price
                quantity: $quantity
              ) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "bidStateAddress": bid_state_address,
            "price": price,
            "quantity": quantity,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TcompEditBidTx.model_validate(data)

    async def tcomp_cancel_coll_bid_tx(
        self, bid_state_address: str, **kwargs: Any
    ) -> TcompCancelCollBidTx:
        query = gql(
            """
            query TcompCancelCollBidTx($bidStateAddress: String!) {
              tcompCancelCollBidTx(bidStateAddress: $bidStateAddress) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"bidStateAddress": bid_state_address}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TcompCancelCollBidTx.model_validate(data)

    async def hswap_buy_nft_tx(
        self,
        buyer: str,
        math_counter: float,
        max_price_lamports: Any,
        mint: str,
        pair: str,
        **kwargs: Any
    ) -> HswapBuyNftTx:
        query = gql(
            """
            query HswapBuyNftTx($buyer: String!, $mathCounter: Float!, $maxPriceLamports: Decimal!, $mint: String!, $pair: String!) {
              hswapBuyNftTx(
                buyer: $buyer
                mathCounter: $mathCounter
                maxPriceLamports: $maxPriceLamports
                mint: $mint
                pair: $pair
              ) {
                txs {
                  lastValidBlockHeight
                  tx
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "buyer": buyer,
            "mathCounter": math_counter,
            "maxPriceLamports": max_price_lamports,
            "mint": mint,
            "pair": pair,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return HswapBuyNftTx.model_validate(data)

    async def hswap_sell_nft_tx(
        self,
        math_counter: float,
        min_price_lamports: Any,
        mint: str,
        pair: str,
        seller: str,
        **kwargs: Any
    ) -> HswapSellNftTx:
        query = gql(
            """
            query HswapSellNftTx($mathCounter: Float!, $minPriceLamports: Decimal!, $mint: String!, $pair: String!, $seller: String!) {
              hswapSellNftTx(
                mathCounter: $mathCounter
                minPriceLamports: $minPriceLamports
                mint: $mint
                pair: $pair
                seller: $seller
              ) {
                txs {
                  lastValidBlockHeight
                  tx
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "mathCounter": math_counter,
            "minPriceLamports": min_price_lamports,
            "mint": mint,
            "pair": pair,
            "seller": seller,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return HswapSellNftTx.model_validate(data)

    async def tswap_buy_nft_tx(
        self, buyer: str, max_price_lamports: Any, mint: str, pool: str, **kwargs: Any
    ) -> TswapBuyNftTx:
        query = gql(
            """
            query TswapBuyNftTx($buyer: String!, $maxPriceLamports: Decimal!, $mint: String!, $pool: String!) {
              tswapBuyNftTx(
                buyer: $buyer
                maxPriceLamports: $maxPriceLamports
                mint: $mint
                pool: $pool
              ) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "buyer": buyer,
            "maxPriceLamports": max_price_lamports,
            "mint": mint,
            "pool": pool,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapBuyNftTx.model_validate(data)

    async def tswap_sell_nft_tx(
        self,
        min_price_lamports: Any,
        mint: str,
        pool: str,
        seller: str,
        seller_token_account: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> TswapSellNftTx:
        query = gql(
            """
            query TswapSellNftTx($minPriceLamports: Decimal!, $mint: String!, $pool: String!, $seller: String!, $sellerTokenAccount: String) {
              tswapSellNftTx(
                minPriceLamports: $minPriceLamports
                mint: $mint
                pool: $pool
                seller: $seller
                sellerTokenAccount: $sellerTokenAccount
              ) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "minPriceLamports": min_price_lamports,
            "mint": mint,
            "pool": pool,
            "seller": seller,
            "sellerTokenAccount": seller_token_account,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapSellNftTx.model_validate(data)

    async def tswap_init_pool_tx(
        self, config: PoolConfig, owner: str, slug: str, **kwargs: Any
    ) -> TswapInitPoolTx:
        query = gql(
            """
            query TswapInitPoolTx($config: PoolConfig!, $owner: String!, $slug: String!) {
              tswapInitPoolTx(config: $config, owner: $owner, slug: $slug) {
                pool
                txs {
                  lastValidBlockHeight
                  tx
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"config": config, "owner": owner, "slug": slug}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapInitPoolTx.model_validate(data)

    async def tswap_deposit_withdraw_nft_tx(
        self, action: DepositWithdrawAction, mint: str, pool: str, **kwargs: Any
    ) -> TswapDepositWithdrawNftTx:
        query = gql(
            """
            query TswapDepositWithdrawNftTx($action: DepositWithdrawAction!, $mint: String!, $pool: String!) {
              tswapDepositWithdrawNftTx(action: $action, mint: $mint, pool: $pool) {
                txs {
                  lastValidBlockHeight
                  tx
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"action": action, "mint": mint, "pool": pool}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapDepositWithdrawNftTx.model_validate(data)

    async def tswap_deposit_withdraw_sol_tx(
        self, action: DepositWithdrawAction, lamports: Any, pool: str, **kwargs: Any
    ) -> TswapDepositWithdrawSolTx:
        query = gql(
            """
            query TswapDepositWithdrawSolTx($action: DepositWithdrawAction!, $lamports: Decimal!, $pool: String!) {
              tswapDepositWithdrawSolTx(action: $action, lamports: $lamports, pool: $pool) {
                txs {
                  lastValidBlockHeight
                  tx
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "action": action,
            "lamports": lamports,
            "pool": pool,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapDepositWithdrawSolTx.model_validate(data)

    async def tswap_close_pool_tx(self, pool: str, **kwargs: Any) -> TswapClosePoolTx:
        query = gql(
            """
            query TswapClosePoolTx($pool: String!) {
              tswapClosePoolTx(pool: $pool) {
                txs {
                  lastValidBlockHeight
                  tx
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"pool": pool}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapClosePoolTx.model_validate(data)

    async def tswap_edit_pool_tx(
        self, new_config: PoolConfig, pool: str, **kwargs: Any
    ) -> TswapEditPoolTx:
        query = gql(
            """
            query TswapEditPoolTx($newConfig: PoolConfig!, $pool: String!) {
              tswapEditPoolTx(newConfig: $newConfig, pool: $pool) {
                pool
                txs {
                  lastValidBlockHeight
                  tx
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"newConfig": new_config, "pool": pool}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapEditPoolTx.model_validate(data)

    async def tswap_list_nft_tx(
        self, mint: str, owner: str, price: Any, **kwargs: Any
    ) -> TswapListNftTx:
        query = gql(
            """
            query TswapListNftTx($mint: String!, $owner: String!, $price: Decimal!) {
              tswapListNftTx(mint: $mint, owner: $owner, price: $price) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"mint": mint, "owner": owner, "price": price}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapListNftTx.model_validate(data)

    async def tswap_delist_nft_tx(
        self, mint: str, owner: str, **kwargs: Any
    ) -> TswapDelistNftTx:
        query = gql(
            """
            query TswapDelistNftTx($mint: String!, $owner: String!) {
              tswapDelistNftTx(mint: $mint, owner: $owner) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"mint": mint, "owner": owner}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapDelistNftTx.model_validate(data)

    async def tswap_edit_single_listing_tx(
        self, mint: str, owner: str, price: Any, **kwargs: Any
    ) -> TswapEditSingleListingTx:
        query = gql(
            """
            query TswapEditSingleListingTx($mint: String!, $owner: String!, $price: Decimal!) {
              tswapEditSingleListingTx(mint: $mint, owner: $owner, price: $price) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {"mint": mint, "owner": owner, "price": price}
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapEditSingleListingTx.model_validate(data)

    async def tswap_buy_single_listing_tx(
        self, buyer: str, max_price: Any, mint: str, owner: str, **kwargs: Any
    ) -> TswapBuySingleListingTx:
        query = gql(
            """
            query TswapBuySingleListingTx($buyer: String!, $maxPrice: Decimal!, $mint: String!, $owner: String!) {
              tswapBuySingleListingTx(
                buyer: $buyer
                maxPrice: $maxPrice
                mint: $mint
                owner: $owner
              ) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "buyer": buyer,
            "maxPrice": max_price,
            "mint": mint,
            "owner": owner,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapBuySingleListingTx.model_validate(data)

    async def tswap_exchange_nft_tx(
        self,
        max_price_lamports: Any,
        min_price_lamports: Any,
        mint_to_buy: str,
        mint_to_sell: str,
        pool: str,
        taker: str,
        **kwargs: Any
    ) -> TswapExchangeNftTx:
        query = gql(
            """
            query TswapExchangeNftTx($maxPriceLamports: Decimal!, $minPriceLamports: Decimal!, $mintToBuy: String!, $mintToSell: String!, $pool: String!, $taker: String!) {
              tswapExchangeNftTx(
                maxPriceLamports: $maxPriceLamports
                minPriceLamports: $minPriceLamports
                mintToBuy: $mintToBuy
                mintToSell: $mintToSell
                pool: $pool
                taker: $taker
              ) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "maxPriceLamports": max_price_lamports,
            "minPriceLamports": min_price_lamports,
            "mintToBuy": mint_to_buy,
            "mintToSell": mint_to_sell,
            "pool": pool,
            "taker": taker,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TswapExchangeNftTx.model_validate(data)

    async def take_bid_tx(
        self, bidder: str, mint: str, price: Any, seller: str, **kwargs: Any
    ) -> TakeBidTx:
        query = gql(
            """
            query TakeBidTx($bidder: String!, $mint: String!, $price: Decimal!, $seller: String!) {
              takeBidTx(bidder: $bidder, mint: $mint, price: $price, seller: $seller) {
                txs {
                  lastValidBlockHeight
                  tx
                  txV0
                }
              }
            }
            """
        )
        variables: Dict[str, object] = {
            "bidder": bidder,
            "mint": mint,
            "price": price,
            "seller": seller,
        }
        response = await self.execute(query=query, variables=variables, **kwargs)
        data = self.get_data(response)
        return TakeBidTx.model_validate(data)
